#ifndef E_CFG_H
#define E_CFG_H

typedef struct _Illume_Cfg Illume_Cfg;

struct _Illume_Cfg
{
   struct {
      int mode;
      int icon_size;
      int single_click;
   } launcher;
   
   struct {
      int auto_suspend;
      int auto_suspend_delay;
   } power;
   
   struct {
      int cache_level; // DOME?
      int fps;
   } performance;
   
   struct {
      int main_gadget_size;
      int extra_gagdet_size;
   } slipshelf;
   
   struct {
      struct {
	 int duration;
      } slipshelf, kbd, busywin, layout;
   } sliding;
   
   // e_config->thumbscroll_enable
   // e_config->thumbscroll_threshhold
   // e_config->thumbscroll_momentum_threshhold
   // e_config->thumbscroll_friction
   // 
   // e_config->screensaver_enable
   // e_config->screensaver_timeout
   // 
   // e_config->framerate
   // 
   // (summarise as 1 cache value setting)
   // e_config->image_cache
   // e_config->font_cache
   // e_config->edje_cache
   // e_config->edje_collection_cache
   // e_config->cache_flush_poll_interval
   // 
   // e_config->desktop_default_background // DOME?
   // 
   // e_config->themes // DOME?
   
   // shelf gadget contents...
   // battery config needs improvement.
   // modules config... needs to fit
};

EAPI int e_cfg_init(E_Module *m);
EAPI int e_cfg_shutdown(void);

EAPI int e_cfg_save(void);

EAPI void e_cfg_launcher(E_Container *con, const char *params);
EAPI void e_cfg_power(E_Container *con, const char *params);
EAPI void e_cfg_animation(E_Container *con, const char *params);
EAPI void e_cfg_slipshelf(E_Container *con, const char *params);
EAPI void e_cfg_thumbscroll(E_Container *con, const char *params);
EAPI void e_cfg_fps(E_Container *con, const char *params);
EAPI void e_cfg_gadgets(E_Container *con, const char *params);
    
extern EAPI Illume_Cfg *illume_cfg;

#endif
